(define pi/4 (atan 1))
(define pi/2 (* pi/4 2))
(define pi (* pi/4 4))

(define (pt x y a b ang)
  (let ((p (make-rectangular x y))
	(d1 (make-polar a ang))
	(d2 (make-polar b (+ ang pi/2))))
    (make-segment (coords-c p) (coords-c (+ p d1)))
    (make-segment (coords-c p) (coords-c (+ p d2)))
    (make-segment (coords-c (+ p d1)) (coords-c (+ p d2)))))


	
(define (make-grid sx sy ox oy nx ny)
  (let ((mx (+ sx (* nx ox)))
	(my (+ sy (* ny oy))))
    (do ((x sx (+ x ox)))
	((> x mx))
      (make-segment (coords x sy) (coords x my)))
    (do ((y sy (+ y oy)))
	((> y my))
      (make-segment (coords sx y) (coords mx y)))))



(define (rt p h1 h2 h3 d)
  (if (> d 0)
    (rt p
	(h-center (make-parametric-point (make-segment h1 h2) p))
	(h-center (make-parametric-point (make-segment h2 h3) p))
	(h-center (make-parametric-point (make-segment h3 h1) p))
	(- d 1))))
	
(define (rt2 p d x1 y1 x2 y2 x3 y3)
  (rt p 
      (h-center (make-ellipse (coords x1 y1) 7 7 0))
      (h-center (make-ellipse (coords x2 y2) 7 7 0))
      (h-center (make-ellipse (coords x3 y3) 7 7 0))
      d))



(define (random-color)
  (list 'rgb (random 256) (random 256) (random 256)))

(define (hallucination)
  (for-each (lambda (x)
	      (set-property! x 'stroke-color (random-color))
	      (set-property! x 'stroke-cap '(cap-style round))
	      (set-property! x 'stroke-width (random 5)))
	    (g-children (active-group))))
	    
(define (add-decors n rad rot)
  (for-each
    (lambda (go)
        (for-each 
            (lambda (h)
	      (trans (lambda () (make-decorator-point h n rad rot))
	    	     (lambda x x)))
            (go-hangers go)))
    (g-children (active-group))))

(define (addx-decors n rad rot)
  (for-each
    (lambda (go)
      (if (not (or  (proxy? go 'go 'parametric-point)
    		    (proxy? go 'go 'decorator-point)
    		    (proxy? go 'go 'intersection)))
          (for-each 
            (lambda (a)
	      (make-decorator-point (anchor-hanger a) n rad rot))
            (go-anchors go)))) 
    (g-children (active-group))))
	  


