(define (kochline p1 p2 dpt spoon)
  (if (= dpt 0)
      (let* ((mc1 (coords-c p1)) (mc2 (coords-c p2)))
	(make-segment mc1 mc2)
	(make-segment mc1 spoon)
	(make-segment spoon mc2))

      (let* ((delta (/ (- p2 p1) 3))
	     (pn1 (+ p1 delta))
	     (pn2 (+ pn1 (make-polar (magnitude delta) (+ (angle delta) (/ pi 3)))))
	     (pn3 (+ pn1 delta))
	     (nd (- dpt 1)))
	(kochline p1 pn1 nd spoon)
	(kochline pn1 pn2 nd spoon)
	(kochline pn2 pn3 nd spoon)
	(kochline pn3 p2 nd spoon))))

(define (koch x1 y1 x2 y2 x3 y3 dpt spoon)
  (kochline (make-rectangular x1 y1) (make-rectangular x2 y2) dpt spoon)
  (kochline (make-rectangular x2 y2) (make-rectangular x3 y3) dpt spoon)
  (kochline (make-rectangular x3 y3) (make-rectangular x1 y1) dpt spoon))

(define (gruel tlo dpt spoon-x spoon-y)
  (trans-main tlo (lambda () (koch -20 -20 0 20 20 -20 dpt (go-get-first-hanger (make-point (mc-new spoon-x spoon-y)))))))

