/*
 * FONTLIB - Testing program
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#include "lib/lib.h"
#include "font/font.h"
#include "geomlib/geomlib.h"
#include <strings.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#if 0
static void draw(struct font_ctl *ctl)
{
	int i, j;
	byte c;
	for (i=ctl->height-1; i>=0; i--) {
		for (j=0; j<ctl->width; j++) {
			c = ctl->bitmap[i*ctl->width + j];
			msg(c==0 ? " " : c<128 ? "+" : "*");
		}
		msg("|\n");
	}
}

static void test_pdf_sections(int fntid)
{
	const char *fname = font_filename(fntid);
	int fd;
	struct stat stat;

	if (!fname)
		die("Can't get filename\n");
	fd = open(fname, O_RDONLY);
	if (fd<0)
		die("Can't open file\n");
	if (fstat(fd, &stat)<0)
		die("Can't stat file\n");

	byte buf[stat.st_size];
	if (read(fd, buf, stat.st_size) != stat.st_size)
		die("Error reading file\n");

	uns l, t, e, f;
	msg("Scanning for sections\n");
	if (font_pfb_sections(buf, stat.st_size, &l, &t, &e, &f)<0)
		msg("Error occured\n");
	else
		msg("Got pfb length=%d text=%d encrypted=%d fixed=%d\n", l, t, e, f);
}
#endif

int main(int argc, char **argv)
{
#if 0
	int id;
	char *str = "ahoj!";
	struct font_ctl ctl;
	struct geom_rectangle bbox;
#endif
	const char *s;

	if (argc < 2)
		return 0;

	font_init(argv[0]);
	char buf[1024];

	if (argc == 2)
		s = font_search(argv[1], NULL, buf, sizeof(buf));
	else
		s = font_search(argv[1], argv[2], buf, sizeof(buf));
	msg("'%s (%s)' --> '%s'\n", argv[1], (argc == 2 ? "" : argv[2]), (s ? s : "???"));

#if 0
	if (!(id = font_load_file(argv[1])))
		die("Error loading font %s\n", argv[1]);

	font_info_dump(id);

	font_ctl_init(&ctl);
	ctl.font_id = id;
	ctl.font_size = 20;
	// geom_transform_set_scale(&ctl.transform, 1000, 1000);
	int k;

	// test_pdf_sections(id);
#endif
	

#if 0
	struct geom_pathset pathset;

	ctl.charmap = FONT_CHARMAP_NONE;
	for (k=0; k < 128 ; k++) {
		geom_pathset_init(&pathset);
		msg("Decomposing character %d:\n", k);
		if (font_char_decompose(&ctl, k, &pathset))
			die("Decomposition failed\n");
		geom_pathset_dump(&pathset);
		geom_pathset_destroy(&pathset);
	}
#endif

#if 0
	ctl.charmap = FONT_CHARMAP_NONE;
	for (k=0; k<128; k++) {
		msg("Rendering charcode %d\n", k);
		if (font_get_glyph_bbox(&ctl, k, &bbox)<0)
			die("Error computing bbox\n");
		msg("bbox: [%f, %f]  [%f, %f]\n", bbox.ll.x, bbox.ll.y, bbox.ur.x, bbox.ur.y);
		if (font_render_glyph(&ctl, k)<0)
			die("Error rendering glyph\n");
		msg("bmpsize=%d w=%d h=%d xoff=%d yoff=%d\n", ctl.bsize, ctl.width, ctl.height, ctl.xoff, ctl.yoff);
		draw(&ctl);
	}
#endif
#if 0
	ctl.charmap = FONT_CHARMAP_STD;
	for (k=0; k<(int)strlen(str); k++) {
		msg("Rendering character '%c'.\n", str[k]);

		if (font_get_glyph_bbox(&ctl, str[k], &bbox)<0)
			die("Error computing bbox\n");
		msg("bbox: [%f, %f]  [%f, %f]\n", bbox.ll.x, bbox.ll.y, bbox.ur.x, bbox.ur.y);
		if (font_render_glyph(&ctl, str[k])<0)
			die("Error rendering glyph\n");
		msg("bmpsize=%d w=%d h=%d xoff=%d yoff=%d\n", ctl.bsize, ctl.width, ctl.height, ctl.xoff, ctl.yoff);
		draw(&ctl);
	}
#endif
#if 0
	ctl.charmap = FONT_CHARMAP_STD;
	str = "Sojka?";
	for (real a=0; a < 4; a += 0.1) {
		geom_transform_set_rotation(&ctl.transform, a);
		if (font_get_string_bbox(&ctl, str, &bbox)<0)
			die("Error computing string bbox\n");
		msg("got bbox of '%s': [%f,%f] [%f,%f]\n", str, bbox.ll.x, bbox.ll.y, bbox.ur.x, bbox.ur.y);
		if (font_render_string(&ctl, str)<0)
			die("Error rendering string\n");
		msg("bmpsize=%d w=%d h=%d xoff=%d yoff=%d\n", ctl.bsize, ctl.width, ctl.height, ctl.xoff, ctl.yoff);
		draw(&ctl);
	}
#endif
#if 0
	ctl.charmap = FONT_CHARMAP_STD;
	// ctl.transform = geom_transform_vflip;
	if (font_render_string(&ctl, str)<0)
		die("Error rendering string\n");
	msg("bmpsize=%d w=%d h=%d xoff=%d yoff=%d\n", ctl.bsize, ctl.width, ctl.height, ctl.xoff, ctl.yoff);
	draw(&ctl);
#endif

	// font_ctl_cleanup(&ctl);
	font_finish();
	return 0;
}
