/*
 * GEOMLIB - Startup inits
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#define GEOM_SOURCE
#include "geomlib/geomlib.h"
#include "lib/cache.h"


/* Classes virtual data structures initialization. */

GEOM_CLASS_DEF(item);
GEOM_CLASS_DEF(group);
GEOM_CLASS_DEF(curve);
GEOM_CLASS_DEF(segment);
GEOM_CLASS_DEF(bezier);
GEOM_CLASS_DEF(arc);
GEOM_CLASS_DEF(elliptic_arc);
GEOM_CLASS_DEF(path);
GEOM_CLASS_DEF(fpath);
GEOM_CLASS_DEF(pathset);
GEOM_CLASS_DEF(point_item);
GEOM_CLASS_DEF(callback_item);

static void geom_classes_init(void)
{
	GEOM_CLASS_INIT(item);
	GEOM_CLASS_INIT(group);
	GEOM_CLASS_INIT(curve);
	GEOM_CLASS_INIT(segment);
	GEOM_CLASS_INIT(bezier);
	GEOM_CLASS_INIT(arc);
	GEOM_CLASS_INIT(elliptic_arc);
	GEOM_CLASS_INIT(path);
	GEOM_CLASS_INIT(fpath);
	GEOM_CLASS_INIT(pathset);
	GEOM_CLASS_INIT(point_item);
	GEOM_CLASS_INIT(callback_item);
}


/* geomlib_init */

void geomlib_init(void)
{
	geom_classes_init();
	geom_cache_init();
}


/* geomlib_finish */

void geomlib_finish(void)
{
	geom_cache_finish();
}

