#ifndef _GUI_GUILE_ACCESS_
#define _GUI_GUILE_ACCESS_

/*
 * GUI - Scheme bindings
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#include "scheme/scheme_def.h"

SCHEME static SO_obj_doc active_document(void)
{ return (context . doc); }

SCHEME static SO_obj_tlo active_page(void)
{ return (context . tlo); }

SCHEME static SO_go_group active_group(void)
{ return (context . group); }

SCHEME static SW_window active_window(void)
{ return (context . w); }

SCHEME static SW_view active_view(void)
{
  if ((context . w) && (context . w -> type == WT_VIEW))
    return ((struct view *) (context . w)); 
  else
    return (NULL);
}

SCHEME static SW_view make_view(SO_go_group group)
{ return (create_view (group)); }

SCHEME static SVOID view_set_center(SW_view vw, SREAL x, SREAL y)
{ visualisation_center (&(vw -> vis), x, y); }

SCHEME static SVOID view_move(SW_view vw, SREAL x, SREAL y)
{ visualisation_move (&(vw -> vis), x, y); }

SCHEME static SVOID view_rotate(SW_view vw, SREAL angle)
{ visualisation_rotate (&(vw -> vis), angle); }

SCHEME static SVOID view_scale(SW_view vw, SREAL scale_x, SREAL scale_y)
{ visualisation_scale (&(vw -> vis), scale_x, scale_y); }

SCHEME static SVOID view_set_orientation(SW_view vw, SREAL center_x, SREAL center_y, SREAL scale_x, SREAL scale_y, SREAL angle)
{ visualisation_set_orientation (&(vw -> vis), center_x, center_y, scale_x, scale_y, angle); }

SCHEME static SO_go_group view_group(SW_view vw) { return (vw -> group); }
SCHEME static SO_obj_tlo  view_page(SW_view vw)  { return (vw -> tlo); }

SCHEME static SUNS view_width(SW_view vw)  { uns w; view_get_size (vw, &w, NULL); return (w); }
SCHEME static SUNS view_height(SW_view vw) { uns h; view_get_size (vw, &h, NULL); return (h); }

#define VIEW_BODY(MIX1, MIX2, RES) \
{ \
  uns w, h; \
  view_get_size (vw, &w, &h); \
\
  struct geom_point p = {MIX1 * w, MIX2 * h}; \
  visualisation_pixels_to_coords (&(vw -> vis), &p, &p); \
  return (p . RES); \
}

SCHEME static SREAL view_ll_x(SW_view vw) VIEW_BODY (0.0, 1.0, x)
SCHEME static SREAL view_ll_y(SW_view vw) VIEW_BODY (0.0, 1.0, y)
SCHEME static SREAL view_lc_x(SW_view vw) VIEW_BODY (0.5, 1.0, x)
SCHEME static SREAL view_lc_y(SW_view vw) VIEW_BODY (0.5, 1.0, y)
SCHEME static SREAL view_lr_x(SW_view vw) VIEW_BODY (1.0, 1.0, x)
SCHEME static SREAL view_lr_y(SW_view vw) VIEW_BODY (1.0, 1.0, y)
 
SCHEME static SREAL view_cl_x(SW_view vw) VIEW_BODY (0.0, 0.5, x)
SCHEME static SREAL view_cl_y(SW_view vw) VIEW_BODY (0.0, 0.5, y)
SCHEME static SREAL view_cc_x(SW_view vw) VIEW_BODY (0.5, 0.5, x)
SCHEME static SREAL view_cc_y(SW_view vw) VIEW_BODY (0.5, 0.5, y)
SCHEME static SREAL view_cr_x(SW_view vw) VIEW_BODY (1.0, 0.5, x)
SCHEME static SREAL view_cr_y(SW_view vw) VIEW_BODY (1.0, 0.5, y)

SCHEME static SREAL view_ul_x(SW_view vw) VIEW_BODY (0.0, 0.0, x)
SCHEME static SREAL view_ul_y(SW_view vw) VIEW_BODY (0.0, 0.0, y)
SCHEME static SREAL view_uc_x(SW_view vw) VIEW_BODY (0.5, 0.0, x)
SCHEME static SREAL view_uc_y(SW_view vw) VIEW_BODY (0.5, 0.0, y)
SCHEME static SREAL view_ur_x(SW_view vw) VIEW_BODY (1.0, 0.0, x)
SCHEME static SREAL view_ur_y(SW_view vw) VIEW_BODY (1.0, 0.0, y)

#endif

