/*
 * DVI - Testing program
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#include "lib/lib.h"
#include "lib/garr.h"
#include "import/import.h"
#include "font/font.h"
#include <stdio.h>

#include <kpathsea/kpathsea.h>

int main(int argc, char **argv)
{
	FILE *f;
	struct garr *ga;

	ga = garr_new(100,sizeof(struct tex_glyph));
	kpse_set_program_name(argv[0], NULL);
	font_init(argv[0]);

	if (argc<2)
		return 1;
	f = fopen(argv[1], "r");
	if (!f) {
		msg("Cannot open %s.\n", argv[1]);
		return 1;
	}

	import_dvi(f, ga);

	font_finish();
	fclose(f);
	garr_destroy(ga);
	return 0;
}
