#ifndef _LIB_SARRAY_H_
#define _LIB_SARRAY_H_

/*
 * VRRLIB - Small arrays
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

/* FIXME! Tenhle typedef ma moc obecny nazev. */
typedef int element;

struct sarray
{
	uns count_element, count, size;
	struct sarray_node** array;
};

struct sarray_node
{
	uns count, size;
	element array[];
};

struct sarray* sarray_init(struct sarray* s);

void sarray_finish(struct sarray* s);

/*
 * Return pointer to the first node so that the first element of the next node is great than e.
 * If sarray has only one node then it's returned.
 * Null is returned if sarray is empty.
 */
int sarray_find_node(struct sarray* s, element e);

/*
 * Return n so that array[n-1] < e <= array[n].
 * If e < array[0] then 0 is returned.
 * If array[count-1] < e then count is returned.
 */
int sarray_find_element(struct sarray_node* n, element e);

int sarray_is_member(struct sarray* s, element e);

element sarray_insert(struct sarray* s, element e);

element sarray_remove(struct sarray* s, element e);

void sarray_dump(struct sarray* s);

#endif // _SARRAY_H_

