;;; public gui functions interface functions
;;;
;;; Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
;;; This program is distributed under GNU General Public License, see COPYING.

(define-module (vrr gui))
(use-modules (vrr high))

(define-public (view-center-x w) (view-cc-x w))
(define-public (view-center-y w) (view-cc-y w))

(define-public (move-active x y)
  (if (not (active-view)) (error "No active view"))
  (move-selected (active-group) x y))

(define-public (rotate-active angle)
  (if (not (active-view)) (error "No active view"))
  (rotate-selected (active-group) (view-center-x (active-view)) (view-center-y (active-view)) angle))

(define-public (scale-active sx sy)
  (if (not (active-view)) (error "No active view"))
  (scale-selected (active-group) (view-center-x (active-view)) (view-center-y (active-view)) sx sy))

(define-public (skew-active f1x f1y f2x f2y fx fy tx ty)
  (if (not (active-view)) (error "No active view"))
  (skew-selected (active-group) f1x f1y f2x f2y fx fy tx ty))

(define-public (transform-active a b c d e f)
  (if (not (active-view)) (error "No active view"))
  (transform-selected (active-group) a b c d e f))

; FIXME buggy
;(define-public (skew-x-active dx)
;  (if (not (active-view)) (error "No active view"))
;  (let ((av (active-view)))
;    (skew-selected (active-group) (view-cl-x av) (view-cl-y av) (view-cr-x av) (view-cr-y av)
;		   (view-uc-x av) (view-uc-y av) (+ dx (view-uc-x av)) (view-uc-y av))))

;(define-public (skew-y-active dx)
;  (if (not (active-view)) (error "No active view"))
;  (let ((av (active-view)))
;    (skew-selected (active-group) (view-lc-x av) (view-lc-y av) (view-uc-x av) (view-uc-y av)
;		   (view-cr-x av) (view-cr-y av) (view-cr-x av) (+ dy (view-cr-y av)))))

(define-public (remove-active)
  (if (not (active-view)) (error "No active view"))
  (remove-selected (active-group)))

(define-public (copy-active dst-grp)
  (if (not (active-view)) (error "No active view"))
  (copy-selected (active-group) dst-group))

; (define-public (duplicate-active)
;  (if (not (active-view)) (error "No active view"))
;  (copy-selected (active-group) (active-group)))
