/*
 * VCL module
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */

#include "vcl_internal.h"

#include <stdio.h>
#include <stdlib.h>


int vcl_if_node;
int vcl_mid_node_set_data;
int vcl_mid_node_get_data;
int vcl_mid_node_set_parent;
int vcl_mid_node_get_parent;
int vcl_mid_node_get_bbox;


int
vcl_primary_apply_matrix (void * obj, struct geom_transform *dst)
{
  int err = 0;
  for (; ((obj != NULL) && (! vcl_canvas_p (obj)) && (err == 0)); obj = vcl_node_get_parent (obj))
    if (vcl_if_transformation_p (obj))
      err = vcl_transformation_primary_apply_matrix (obj, dst, dst);

  return (err);
}

int
vcl_inverted_apply_matrix (void * obj, struct geom_transform *dst)
{
  int err = 0;
  for (; ((obj != NULL) && (! vcl_canvas_p (obj)) && (err == 0)); obj = vcl_node_get_parent (obj))
    if (vcl_if_transformation_p (obj))
      err = vcl_transformation_inverted_apply_matrix (obj, dst, dst);

  return (err);
}

int
vcl_primary_apply_point (void * obj, struct geom_point *dst)
{
  int err = 0;
  for (; ((obj != NULL) && (! vcl_canvas_p (obj)) && (err == 0)); obj = vcl_node_get_parent (obj))
    if (vcl_if_transformation_p (obj))
      err = vcl_transformation_primary_apply_point (obj, dst, dst);

  return (err);
}

int
vcl_inverted_apply_point (void * obj, struct geom_point *dst)
{
  if ((obj == NULL) || vcl_canvas_p (obj))
    return (0);
  else
    {
      int err = vcl_inverted_apply_point (vcl_node_get_parent (obj), dst);
      if ((! err) && vcl_if_transformation_p (obj))
	return (vcl_transformation_inverted_apply_point (obj, dst, dst));
      else
	return (err);
    }
}


void
vcl_if_node_main (void)
{
  vcl_if_node = vcl_interface_new ("node");

  vcl_mid_node_set_data = vcl_interface_add_method (vcl_if_node);
  vcl_mid_node_get_data = vcl_interface_add_method (vcl_if_node);
  vcl_mid_node_set_parent = vcl_interface_add_method (vcl_if_node);
  vcl_mid_node_get_parent = vcl_interface_add_method (vcl_if_node);
  vcl_mid_node_get_bbox = vcl_interface_add_method (vcl_if_node);
}

