#ifndef _VCL_IF_SHAPE_H_
#define _VCL_IF_SHAPE_H_

/**@file
 *
 * VCL module header
 *
 * Copyright (c) 2004-2005    The VRR Team <vrr@ucw.cz>
 * This program is distributed under GNU General Public License, see COPYING.
 */



extern int vcl_if_shape;

extern int vcl_mid_shape_polygonize;


struct vcl_shape_part
{
  int points;
  int closed;
};

enum vcl_shape_hints
  {
    VCL_SHAPE_CLOSED_ONLY = 1,
    VCL_SHAPE_OPEN_ONLY   = 2
  };


static inline uns
vcl_if_shape_p (void *obj)
{ return (vcl_class_supports_interface_p (VCL_GET_CLASS (obj), vcl_if_shape)); }

/*
  return edges (in pixel space) of shape 'obj' (using iterator 'it'), approximate
  up to factor delta, transformation to pixel space is 't', interesting rectangle (in local space)
  is 'bbox'.
*/

static inline void *
vcl_shape_polygonize (void * obj, void * it, double delta, const struct geom_transform *t,
		      const struct geom_rectangle *bbox, u8 ** buff,
		      uns * buff_len, uns *closed, uns *points, uns hints)
{ return (VCL_METHOD (void *, vcl_mid_shape_polygonize, it, delta, t, bbox, buff, buff_len, closed, points, hints)); }

/*
extern struct vcl_rle_data *
vcl_shape_render_area (void *shape, real delta, struct geom_transform *t,
		       const struct vcl_rectangle *bbox, struct vcl_rectangle *rle_bbox);
*/



#ifdef _VCL_INTERNAL_


extern void
vcl_if_shape_main (void);


#endif
#endif
